function Create(self)

self.mapwrapx = SceneMan.SceneWrapsX;

	self.c = self:GetController();

self.garbTimer = Timer(); 
self.updateInterval = 10;
self.updateTime = Timer();

	self.Vel = Vector(0,0);  
	self.RotAngle = 0;  
	self.rotFactor = 0.15; 

self.flightSwitchTimer = Timer();

self.prevHealth = self.Health;
self.XVARIABLE = 0; 
 
self.Alternate = true;


self.flight = false;

end

function Update(self)

if not(self:IsDead()) and self.Health > 0 then

	--propulsion, stabilisation
	
	self.alt = self:GetAltitude(0,1);

	if self.alt < 75 then
		self.flight = false;
	end

	if self.alt > 75 and self.c:IsState(Controller.BODY_JUMP) then
		self.flight = true;
	end

--CHECK FOR FLIGHT DISABLE
local speed = self.Vel.Magnitude;
if speed >= 10 then 
	local velFactor = GetPPM() * TimerMan.DeltaTimeSecs; 
	local checkVect = self.Vel * velFactor; 
	local terrcheck = Vector(0,0);
	local ray = SceneMan:CastStrengthRay(self.Head.Pos,Vector(speed,0),0,checkVect,1,0,true);
	 if ray == true then
		self.flight = false;
		self:ClearImpulseForces();
		self:ClearForces();
	end
end
--END CHECK


--FLIGHT

if self.flight == false then 
	self.AngularVel = self.AngularVel * 0.96;
else  
		
		local floatvel = math.sin(self.garbTimer.ElapsedSimTimeMS / 190) / 1.5;
		self.Vel.Y = self.Vel.Y + floatvel;

		local ownController = self:GetController();

		self:ClearImpulseForces();  
		  
		if ownController:IsState(Controller.HOLD_LEFT) or self.c:IsState(Controller.MOVE_LEFT) then  
			self.Vel.X = self.Vel.X - 1.25;  
			if self.Vel.X < -30 then  
				self.Vel.X = -30;    
			end  
		elseif ownController:IsState(Controller.HOLD_RIGHT) or self.c:IsState(Controller.MOVE_RIGHT) then  
			self.Vel.X = self.Vel.X + 1.25;  
			if self.Vel.X > 30 then  
				self.Vel.X = 30;  
			end  
		elseif self.Vel.X < 0 then  
			self.Vel.X = self.Vel.X + 1.25 * 0.4;  
			if self.Vel.X > 0 then  
				self.Vel.X = 0;    
			end  
		elseif self.Vel.X > 0 then  
			self.Vel.X = self.Vel.X - 1.25 * 0.4;  
			if self.Vel.X < 0 then  
				self.Vel.X = 0;    
			end  
		end  

		if ownController:IsState(Controller.HOLD_UP) or self.c:IsState(Controller.MOVE_UP) then  
			if self.Vel.Y > 0 then
				self.Vel.Y = self.Vel.Y - 2.05;
			else
				self.Vel.Y = self.Vel.Y - 1.25;  
			end
			if self.Vel.Y < -30 + floatvel then
				self.Vel.Y = -30 + floatvel;
			end
		elseif ownController:IsState(Controller.HOLD_DOWN) or self.c:IsState(Controller.MOVE_DOWN) then  
			self.Vel.Y = self.Vel.Y + 1.25;
			if self.Vel.Y > 30 + floatvel then
				self.Vel.Y = 30 + floatvel;
			end   
		elseif self.Vel.Y < 0 then  
			self.Vel.Y = self.Vel.Y + 1.25 * 0.5;

			if self.Vel.Y > -0.334 + floatvel then
				self.Vel.Y = -0.334 + floatvel;
			end  
		elseif self.Vel.Y > -0.334 then
			self.Vel.Y = self.Vel.Y - 1.25 * 1.1;
			if self.Vel.Y < -0.334 + floatvel then
				self.Vel.Y = -0.334 + floatvel;
			end  
		end

--TILT CALCULATION FOR FLIGHT
	if self.Vel.Y > 0 then
		self.rotFactor = 0.15 + (0.056 * self.Vel.Y)
	end
		self.RotAngle = self.rotFactor * -(self.Vel.X / 30);
		self.AngularVel = 0; 
end 


--CLEAR FORCES IN CASE OF IMPACT
local angvel = self.AngularVel
if angvel > 20 or angvel < -20 then
	self.AngularVel = angvel * 0.75;
end

end


--DECOMPRESS
	if self.Health <= 0 then

		self.alt = self:GetAltitude(0,1);
		if self.alt < 18 then

		local decompress = CreateAEmitter("Battlesuit Splatter", "Tau.rte");  
		decompress.Pos = self.Pos
		decompress.Vel = self.Vel;

if self.HFlipped == false then
		decompress.RotAngle = self.RotAngle - 0.35;
else
		decompress.RotAngle = self.RotAngle + math.pi + 0.35;
end

		decompress:SetWhichMOToNotHit(self,-1);
		MovableMan:AddParticle(decompress); 
		end


		self.Flight = false;

	end


--GARBAGE COLLECTION 
	if self.garbTimer:IsPastSimMS(12000) then
		collectgarbage("collect");
		self.garbTimer:Reset();
	end 

end
