function Create(self)
	self.Target = nil;
	self.GoldTeam = nil;
	self.OriginalSharpness = 0;
	self.TargetPicked = false;
	self.Template = CreateACRocket("Parachute" , "RCSA.rte");
	self.Price = self.Template:GetGoldValue(0 , 1);
	if self.Vel.Y < 1 then
		self.Vel.Y = 1;
	end
	self.MaxActors = 1000;
	self.NumberAdded = 0;
	self.AllMade = false;
	self.Vel.Y = 3
end
--PresetMan:ReloadAllScripts()
function Update(self)
	local newchute = nil;
	--Add nearby actors to the table
	self.AttachedActors = {}
	if #self.AttachedActors < self.MaxActors then
		for actor in MovableMan.Actors do
			if self.AllMade == false then
				--if self.TargetPicked == false then
					if actor.ID ~= self.ID and SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX).Magnitude < 40 then
						self.AttachedActors[#self.AttachedActors + 1] = actor;
					end
				--end
			end
		end
	end
	if self.AllMade == true then
		if self.TargetPicked == true and MovableMan:IsActor(self.Target) then
			for i = 2 , #self.AttachedActors do
				if self.AttachedActors[i] then
					table.remove(self.AttachedActors , i);
				end
			end
			self.AttachedActors[1]  = self.Target;
		end
	end

	--Flag as true if you've added enough chutes
	if self.NumberAdded >= #self.AttachedActors then
		self.AllMade = true;
	end
	--If you buy more than one actor then:
	if #self.AttachedActors > 0 then
		if #self.AttachedActors > 1 and self.Age < 1000 then
			local adist = 0
			for i = 1 , #self.AttachedActors do
				if self.TargetPicked == false then
					--Pick the closest actor and mark him as the one this parachute carries
					if i == 1 then
						self.Target = self.AttachedActors[i];
						adist = SceneMan:ShortestDistance(self.Pos,self.Target.Pos,SceneMan.SceneWrapsX).Magnitude;
					else
						local dist = SceneMan:ShortestDistance(self.Pos,self.AttachedActors[i].Pos,SceneMan.SceneWrapsX).Magnitude;
						if dist < adist then
							self.Target = self.AttachedActors[i];
							self.OriginalSharpness = self.Target.Sharpness;
							adist = dist;
						end
					end
					self.Target.Sharpness = 100;
					self.TargetPicked = true;
				end
				if self.TargetPicked == true and MovableMan:IsActor(self.Target) then
					self.GoldTeam = self.Target.Team

					--Make new parachutes for all the others, take away gold.
					if self.AttachedActors[i] and self.AllMade == false then
						if self.AttachedActors[i].ID ~= self.Target.ID and self.AttachedActors[i].Team == self.GoldTeam and self.AttachedActors[i].Sharpness ~= 100 then

							--Move the actor away from self.Target
							if SceneMan:ShortestDistance(self.Target.Pos,self.AttachedActors[i].Pos,SceneMan.SceneWrapsX).Magnitude < 50 then
								if self.AttachedActors[i].Pos.X - self.Target.Pos.X > 0 then
									self.AttachedActors[i].Pos.X = self.Target.Pos.X - math.random(50 , 100);
									self.AttachedActors[i].Vel.X = -1;
								elseif self.AttachedActors[i].Pos.X - self.Target.Pos.X < 0 then
									self.AttachedActors[i].Pos.X = self.Target.Pos.X + math.random(50 , 100);
									self.AttachedActors[i].Vel.X = 1;
								end
							end

							--Make a new parachute for them and take away gold. The new chute is scripted so it only hooks to one actor and does little else
							newchute = CreateACRocket("Parachute B" , "RCSA.rte");
							newchute.Pos = self.AttachedActors[i].Pos;
							MovableMan:AddActor(newchute);
							ActivityMan:GetActivity():SetTeamFunds(ActivityMan:GetActivity():GetTeamFunds(self.GoldTeam) - self.Price , self.GoldTeam);

							--Increase the count to tell if all the necessary parachutes have been added. Then remove the actor from the table.
							self.NumberAdded = self.NumberAdded + 1;
							table.remove(self.AttachedActors , i);
						end
						if self.AttachedActors[i] ~= nil then
							if self.AttachedActors[i].Sharpness == 100 and self.AttachedActors[i].ID ~= self.Target.ID then
								--print("has chute, remove");
								table.remove(self.AttachedActors , i);
							end
						end
					end
				end
			end
		end

		--Move the parachute when the actor attached to it moves, set a few things true to stop chute stealing and stuff
		if #self.AttachedActors == 1 then
			--self.MaxActors = 1;
			if not self.TargetPicked == true and MovableMan:IsActor(self.AttachedActors[1]) then
				self.Target = self.AttachedActors[1];
				self.TargetPicked = true;
			end
			if MovableMan:IsActor(self.Target) then
				self.GoldTeam = self.Target.Team
				self.Target.Sharpness = 100;
				self.Target.Pos = self.Pos
				self.Target.Vel = self.Vel
				self.Target:GetController():SetState(Controller.BODY_JUMP , false);
				self.Target:GetController():SetState(Controller.BODY_JUMPSTART , false);
				self.Target:GetController():SetState(Controller.BODY_CROUCH , false);
				self.Target:GetController():SetState(Controller.MOVE_RIGHT , false);
				self.Target:GetController():SetState(Controller.MOVE_LEFT , false);
				if self.Target:GetController():IsState(Controller.HOLD_RIGHT) and self.Vel.X < 4 then
					self.Vel.X = self.Vel.X + 0.25;
					if  self.RotAngle < 0.1 then
						self.RotAngle = self.RotAngle + 0.03
					end
				elseif self.Target:GetController():IsState(Controller.HOLD_LEFT) and self.Vel.X > -4 then
					self.Vel.X = self.Vel.X - 0.25;
					if  self.RotAngle > -0.1 then
						self.RotAngle = self.RotAngle - 0.03
					end
				end
			end
		end
	end

	--Gib if no actor attached and refund money
	if #self.AttachedActors == 0 or self.Target == nil then
		if not self.GoldTeam then
			self.GoldTeam = 0;
		end
		if self.GoldTeam then
			ActivityMan:GetActivity():SetTeamFunds(ActivityMan:GetActivity():GetTeamFunds(self.GoldTeam) + self.Price , self.GoldTeam);
		end
		self.ToDelete = true;
		--print ("not attached delete");
	end

	--Gib when it hits the ground
	if self:GetAltitude(0,2) < 50 then
		self:GibThis();
		if self.Target ~= nil then
			self.Target.Sharpness = self.OriginalSharpness;
			--print ("sharpness reset to"..tostring(self.OriginalSharpness));
		end
	end
end