function Create(self)
	self.StartTimer = Timer();
	self.healnum = 0;
	self.TargetPicked = false;
	self.Target = nil;
	self.GoldTeam = 0;
	self.Template = CreateACRocket("Parachute" , "RCSA.rte");
	self.Price = self.Template:GetGoldValue(0 , 1);
	self.OriginalSharpness = 0;
	self.Vel.Y = 3;
end
--PresetMan:ReloadAllScripts()
function Update(self)
	self.AttachedActors = {}

	--Do everything for when there's no target picked yet
	if self.TargetPicked == false then
		--Add nearby actors to the table
		for actor in MovableMan.Actors do
			if actor.ID ~= self.ID and SceneMan:ShortestDistance(self.Pos,actor.Pos,SceneMan.SceneWrapsX).Magnitude < 40 then
				self.AttachedActors[#self.AttachedActors + 1] = actor;
			end
		end

		--Find the target;
		local adist = 0
		if #self.AttachedActors > 0 then
			for i = 1 , #self.AttachedActors do
				--Pick the closest actor and mark him as the one this parachute carries
				if i == 1 then
					self.Target = self.AttachedActors[i];
					adist = SceneMan:ShortestDistance(self.Pos,self.Target.Pos,SceneMan.SceneWrapsX).Magnitude;
				else
					local dist = SceneMan:ShortestDistance(self.Pos,self.AttachedActors[i].Pos,SceneMan.SceneWrapsX).Magnitude;
					if dist < adist then
						self.Target = self.AttachedActors[i];
						self.OriginalSharpness = self.Target.Sharpness;
						adist = dist;
					end
				end
			end
		end
	end

	--Set a couple flags when a target exists
	if MovableMan:IsActor(self.Target) then
		self.TargetPicked = true;
		self.GoldTeam = self.Target.Team;
	end

	--Do everything for when you have a target
	if self.TargetPicked == true then
		if MovableMan:IsActor(self.Target) then

			--Flag actors and fiddle with tables
			for i = 2 , #self.AttachedActors do
				if self.AttachedActors[i] then
					table.remove(self.AttachedActors , i);
				end
			end
			self.AttachedActors[1] = self.Target;
		
			--Move the parachute when the actor attached to it moves
			self.Target.Pos = self.Pos
			self.Target.Vel = self.Vel

			self.Target:GetController():SetState(Controller.BODY_JUMP , false);
			self.Target:GetController():SetState(Controller.BODY_JUMPSTART , false);
			self.Target:GetController():SetState(Controller.BODY_CROUCH , false);
			self.Target:GetController():SetState(Controller.MOVE_RIGHT , false);
			self.Target:GetController():SetState(Controller.MOVE_LEFT , false);
		
			if self.Target:GetController():IsState(Controller.HOLD_RIGHT) and self.Vel.X < 4 then
				self.Vel.X = self.Vel.X + 0.25;
				if  self.RotAngle < 0.1 then
					self.RotAngle = self.RotAngle + 0.03
				end
			elseif self.Target:GetController():IsState(Controller.HOLD_LEFT) and self.Vel.X > -4 then
				self.Vel.X = self.Vel.X - 0.25;
				if  self.RotAngle > -0.1 then
					self.RotAngle = self.RotAngle - 0.03
				end
			end
		end
	end

	--Gib if no actor attached and refund money
	if #self.AttachedActors == 0 or self.Target == nil then
		if not self.GoldTeam then
			self.GoldTeam = 0;
		end
		if self.GoldTeam then
			ActivityMan:GetActivity():SetTeamFunds(ActivityMan:GetActivity():GetTeamFunds(self.GoldTeam) + self.Price , self.GoldTeam);
		end
		self.ToDelete = true;
		--print ("Not Attached - Delete");
	end

	--Gib when it hits the ground
	if self:GetAltitude(0,2) < 50 then
		self:GibThis();
		if self.Target ~= nil then
			self.Target.Sharpness = self.OriginalSharpness;
			--print ("sharpness reset to"..tostring(self.OriginalSharpness));
		end
	end
end