
function ScanVectorForMOTerrainAware(StartPosition, EndPosition, MOIDToIgnore)
	local VectorToDestination = SceneMan:ShortestDistance(StartPosition,EndPosition,true);
	local ResultPosition = EndPosition;
	local ResultMOID = 255;
	local ResultTerrainContact = false;
	CheckTerrain = SceneMan:CastNotMaterialRay(StartPosition, VectorToDestination, 0, 1,false);
	if CheckTerrain < 0 then
		ResultPosition, ResultMOID = ScanVectorForMO(StartPosition, VectorToDestination, MOIDToIgnore);
	else
		VectorToDestination = VectorToDestination.Normalized * CheckTerrain;
		ResultPosition, ResultMOID = ScanVectorForMO(StartPosition, VectorToDestination, MOIDToIgnore);
		if ResultMOID == 255 then
			ResultPosition = StartPosition + VectorToDestination;
			ResultTerrainContact = true;
		end
	end
	return ResultPosition, ResultMOID, ResultTerrainContact;
end

function ScanSectorForMOTerrainAware(StartPosition, ScanAxisVector, Radius, DegreesToScan, ScanStepDegrees, MOIDToIgnore)
	local StepCount = math.ceil(DegreesToScan / ScanStepDegrees);
	local ScanVector = Vector(ScanAxisVector.X,ScanAxisVector.Y):DegRotate(-(DegreesToScan/2));
	local ResultPosition = nil
	local ResultMOID = 255
	for StepNumber = 0, math.ceil(DegreesToScan / ScanStepDegrees), 1 do
		ScanVector = ScanVector:DegRotate(ScanStepDegrees):SetMagnitude(Radius);
		--DrawLine(StartPosition, StartPosition+ScanVector, 1, 0.1, "LBoltBlueLightTiny")
		ResultPosition, ResultMOID = ScanVectorForMOTerrainAware(StartPosition,StartPosition + ScanVector,MOIDToIgnore);
		if ResultMOID ~= 255 then
			break;
		end
	end
	return ResultPosition, ResultMOID;
end

function ScanSectorForActorTerrainAware(StartPosition, ScanAxisVector, Radius, DegreesToScan, ScanStepDegrees, MOIDToIgnore)
	local StepCount = math.ceil(DegreesToScan / ScanStepDegrees);
	local ScanVector = Vector(ScanAxisVector.X,ScanAxisVector.Y):DegRotate(-(DegreesToScan/2));
	local ResultPosition = nil
	local ResultMOID = 255
	for StepNumber = 0, math.ceil(DegreesToScan / ScanStepDegrees), 1 do
		ScanVector = ScanVector:DegRotate(ScanStepDegrees):SetMagnitude(Radius);
		--DrawLine(StartPosition, StartPosition+ScanVector, 1, 0.1, "LBoltBlueLightTiny")
		ResultPosition, ResultMOID = ScanVectorForMOTerrainAware(StartPosition,StartPosition + ScanVector,MOIDToIgnore);
		if ResultMOID ~= 255 and  MovableMan:GetMOFromID(ResultMOID).Class == "AHuman" then
			break;
		end
	end
	return ResultPosition, ResultMOID;
end

function Create(self)
	
	--local curdist = 25;
    --for actor in MovableMan.Actors do
	--local avgx = actor.Pos.X - self.Pos.X;
	--local avgy = actor.Pos.Y - self.Pos.Y;
	--local dist = math.sqrt(avgx ^ 2 + avgy ^ 2);
	--if dist < curdist then
	--    curdist = dist;
	--    self.target = actor;
	--end
    --end
	local count=1;
	local Pos;
	
	Pos, self.target = ScanSectorForMOTerrainAware(self.Pos, Vector(1,1),12,360,6, 255);
	self.target = MovableMan:GetMOFromID(MovableMan:GetRootMOID(self.target));
	
	self.list ={};
	if self.target ~= nil and MovableMan:ValidMO(self.target) then 
		self.TargetRoot = MovableMan:GetMOFromID(MovableMan:GetRootMOID(self.target.ID));	
		for i=-40,40,1 do
			for k=-40,40,1 do
				local PosX = self.TargetRoot.Pos.X+i;
				local PosY = self.TargetRoot.Pos.Y+k;
				if MovableMan:GetRootMOID(SceneMan:GetMOIDPixel(PosX,PosY)) == self.TargetRoot.ID then
					self.list[count]=Vector(PosX,PosY);
					count=count+1;
				end
			end
		end
		self.TargetRoot.ToDelete=true;
		--print(count);
	end
	self.ToDelete=false;
	self.timer = Timer();
	self.flag=false;
end

function Update(self)
	if self.flag==false then 
		for i=1,#self.list,1 do
			partnumber = math.random(6);
			local Particle = CreateMOPixel("Dot@"..tostring(partnumber));
			--print(list[i]);
			Particle.Pos = self.list[i];
			Particle.Vel = Vector(0,0);
			MovableMan:AddParticle(Particle);
		end
		self.flag=true;
	end
	self.ToDelete=true;
end