
function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.startchargetimer = Timer();
	self.chargetimer = Timer();
	self.energycounter = 0;
	self.startcharge = false;

--------------------
----- The variables here can be changed to alter various properties of the shield.

	self.startchargedelay = 555; -- time before the shield starts to charge up after it got hit.
	self.chargedelay = 55; -- charges one energy point after every X miliseconds.
	self.maxenergy = 55; -- maximum amount of energy for the shield.
	self.shieldradius = 55; -- pixel radius of shield.

-----
--------------------
end

function Update(self)
-- SHIELD
    if not(MovableMan:IsParticle(self.energymeter)) then
	self.energymeter = CreateMOSRotating("Shield Meter","RCSA.rte");
	self.energymeter.Pos = self.AboveHUDPos + Vector(0, 10);
	MovableMan:AddParticle(self.energymeter);
    elseif MovableMan:IsParticle(self.energymeter) then
	self.energymeter.ToDelete = false;
	self.energymeter.ToSettle = false;
	self.energymeter:NotResting()
	self.energymeter.HitsMOs = false;
	self.energymeter.RotAngle = 0
	self.energymeter.Pos = self.AboveHUDPos + Vector(0, 10);
	self.energymeter.Frame = math.ceil((self.energycounter/self.maxenergy)*10);
    end

    if self.startchargetimer:IsPastSimMS(self.startchargedelay) and self.chargetimer:IsPastSimMS(self.chargedelay) and self.energycounter < self.maxenergy then
     if self.startcharge == true then
	self.startcharge = false;
     end
	self.chargetimer:Reset();
	self.energycounter = self.energycounter + 1;
    end

    if self.energycounter > 0 then
     for item in MovableMan.Items do
      if item.ClassName == "TDExplosive" and ToTDExplosive(item):IsActivated() == true then

	self.parvector = SceneMan:ShortestDistance(self.Pos,item.Pos,self.mapwrapx);
	self.pardist = self.parvector.Magnitude;
       if self.pardist < self.shieldradius then
	self.anglecheck = (self.parvector*-1).AbsDegAngle-item.Vel.AbsDegAngle;
        if self.anglecheck > -150 and self.anglecheck < 150 then

         if self.energycounter >= math.ceil(item.Mass) then

	item.Vel = Vector(self.parvector.X,self.parvector.Y):SetMagnitude(item.Vel.Magnitude);

	self.energycounter = self.energycounter - math.ceil(item.Mass);
	self.chargetimer:Reset();
	self.startchargetimer:Reset();
	self.startcharge = true;

         elseif self.energycounter < math.ceil(item.Mass) then

	self.energycounter = 0;
	self.chargetimer:Reset();
	break;

         end

        end
       end

      end
     end
    end

    if self.energycounter > 0 then
     for particle in MovableMan.Particles do
      if particle.HitsMOs == true then
	self.parvector = SceneMan:ShortestDistance(self.Pos,particle.Pos,self.mapwrapx);
	self.pardist = self.parvector.Magnitude;
       if self.pardist < self.shieldradius then
	self.anglecheck = (self.parvector*-1).AbsDegAngle-particle.Vel.AbsDegAngle;

        if self.anglecheck > -150 and self.anglecheck < 150 then

         if particle.ClassName == "MOPixel" or particle.ClassName == "MOSParticle" then

	local shieldflash = CreateMOPixel("Shield Hit Glow","RCSA.rte");
	shieldflash.Pos = particle.Pos;
	MovableMan:AddParticle(shieldflash);
	local shieldsound = CreateAEmitter("Sound Shield Hit","RCSA.rte");
	shieldsound.Pos = particle.Pos;
	MovableMan:AddParticle(shieldsound);

	particle.ToDelete = true;

	self.energycounter = self.energycounter - 1;
	self.chargetimer:Reset();
	self.startchargetimer:Reset();
	self.startcharge = true;

          if self.energycounter <= 0 then
	break;
          end

         elseif particle.ClassName == "MOSRotating" or particle.ClassName == "AEmitter" then

          if self.energycounter >= math.ceil(particle.Mass) then

	particle.Vel = Vector(self.parvector.X,self.parvector.Y):SetMagnitude(particle.Vel.Magnitude);

	self.energycounter = self.energycounter - math.ceil(particle.Mass);
	self.chargetimer:Reset();
	self.startchargetimer:Reset();
	self.startcharge = true;

          elseif self.energycounter < math.ceil(particle.Mass) then

	self.energycounter = 0;
	self.chargetimer:Reset();
	break;

          end

         end

        end

       end
      end
     end
    end
end
-- END OF SHIELD